# -*- coding: utf-8 -*-


#マニピュレーターの中心位置を選択ポイントに移動

#マニピュレーターの中心位置を最後に（追加）選択した頂点の中心あるいは辺の中心、面の中心へと移動します。

#動作条件
#選択形状がポリゴンメッシュ
#編集モードに入っている
#頂点編集モードなら頂点が1個以上選択されている、辺編集モードなら辺が1個選択されている、面編集モードなら面が1個選択されている



dousasuru=0
sentakumode=0#0で面編集モード、1で辺編集モード、2で頂点編集モード

if xshade.scene().is_modify_mode==True and xshade.scene().active_shape().type==7:
  if xshade.scene().selection_mode==0:
    sentakumode=0
    activemenlist=[]
    for i in range(xshade.scene().active_shape().number_of_faces):
      if xshade.scene().active_shape().face(i).active_order>0:
        activemenlist.append(i)
    if len(activemenlist)>0:
      dousasuru=1
      #active_orderが一番高い面を探し出す
      lastmen=0
      for gg in range(xshade.scene().active_shape().number_of_faces):
        if xshade.scene().active_shape().face(gg).active_order>xshade.scene().active_shape().face(lastmen).active_order:
          lastmen=gg

  if xshade.scene().selection_mode==1:
    sentakumode=1
    activeedgelist=[]
    for i in range(xshade.scene().active_shape().number_of_edges):
      if xshade.scene().active_shape().edge(i).active_order>0:
        activeedgelist.append(i)
    if len(activeedgelist)>0:
      dousasuru=1
      #active_orderが一番高い辺を探し出す
      lastedge=0
      for gg in range(xshade.scene().active_shape().number_of_edges):
        if xshade.scene().active_shape().edge(gg).active_order>xshade.scene().active_shape().edge(lastedge).active_order:
          lastedge=gg

  if xshade.scene().selection_mode==2:
    sentakumode=2
    activepointlist=[]
    for i in range(xshade.scene().active_shape().total_number_of_control_points):
      if xshade.scene().active_shape().vertex(i).active_order>0:
        activepointlist.append(i)
    if len(activepointlist)>0:
      dousasuru=1
      #active_orderが一番高い頂点を探し出す
      lastpoint=0
      for gg in range(xshade.scene().active_shape().total_number_of_control_points):
        if xshade.scene().active_shape().vertex(gg).active_order>xshade.scene().active_shape().vertex(lastpoint).active_order:
          lastpoint=gg







if dousasuru==1:


  if sentakumode==0:
    #一度全ての面の選択状態を消す
    for i in activemenlist:
      xshade.scene().active_shape().face(i).active=False

    #最後の面だけ選択状態にして編集モードを出て編集モードに入りなおすとマニピュレーターの位置が最後の面の中心に移動
    xshade.scene().active_shape().face(lastmen).active=True
    xshade.scene().exit_modify_mode()
    xshade.scene().enter_modify_mode()
    xshade.idle(180)#これが肝

    #選択していた面を再選択しなおす（編集モードを出ないならマニピュレーターの位置は移動しない）
    for i in activemenlist:
      xshade.scene().active_shape().face(i).active=True

    xshade.scene().active_shape().face(lastmen).active=False
    xshade.scene().active_shape().face(lastmen).active=True


    xshade.scene().update_figure_window()


  if sentakumode==1:
    #一度全ての辺の選択状態を消す
    for i in activeedgelist:
      xshade.scene().active_shape().edge(i).active=False

    #最後に選択した辺だけ選択状態にして編集モードを出て編集モードに入りなおすとマニピュレーターの位置が最後の辺の中心に移動
    xshade.scene().active_shape().edge(lastedge).active=True
    xshade.scene().exit_modify_mode()
    xshade.scene().enter_modify_mode()
    xshade.idle(180)#これが肝

    #選択していた辺を再選択しなおす（編集モードを出ないならマニピュレーターの位置は移動しない）
    for i in activeedgelist:
      xshade.scene().active_shape().edge(i).active=True

    xshade.scene().active_shape().edge(lastedge).active=False
    xshade.scene().active_shape().edge(lastedge).active=True
    xshade.scene().update_figure_window()


  if sentakumode==2:
    #一度全ての頂点の選択状態を消す
    for i in activepointlist:
      xshade.scene().active_shape().vertex(i).active=False

    #最後に選択した辺だけ選択状態にして編集モードを出て編集モードに入りなおすとマニピュレーターの位置が最後の辺の中心に移動
    xshade.scene().active_shape().vertex(lastpoint).active=True
    xshade.scene().exit_modify_mode()
    xshade.scene().enter_modify_mode()
    xshade.idle(180)#これが肝

    #選択していた辺を再選択しなおす（編集モードを出ないならマニピュレーターの位置は移動しない）
    for i in activepointlist:
      xshade.scene().active_shape().vertex(i).active=True
    xshade.scene().active_shape().vertex(lastpoint).active=False
    xshade.scene().active_shape().vertex(lastpoint).active=True
    xshade.scene().update_figure_window()






